// Configuration.cpp: implementation of the CConfiguration class.
//
//////////////////////////////////////////////////////////////////////

#include "../stdafx.h"
#include "Configuration.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CConfiguration::CConfiguration()
{
	Reset();
}

CConfiguration::~CConfiguration()
{
}

void CConfiguration::Reset()
{
	szInputFile="";

	nShift=mShift=0;
	nFrom=nTo=nStep=0;
	nProgressionType=-1;
	bUseExternalProgression=FALSE;
	bGenerateAvg=FALSE;

	szProgressionFile="";
}

#include "../misc.h"

bool CConfiguration::Load(CString szConfigFile)
{
	FILE *f=fopen(szConfigFile, "r");

	if(f==0)
		return false;

	SkipLine(f);
	GetLine(f, szInputFile);
	SkipLine(f);

	SkipLine(f);
	fscanf(f, "%lf\t%lf\n", &nShift, &mShift);
	
	SkipLine(f);
	fscanf(f, "%d\n", &nProgressionType);
	
	SkipLine(f);
	fscanf(f, "%d\t%d\t%d\n", &nFrom, &nTo, &nStep);

	SkipLine(f);
	fscanf(f, "%d\n", &bUseExternalProgression);
	GetLine(f, szProgressionFile);
	SkipLine(f);


	fclose(f);

	return true;

}

bool CConfiguration::Save(CString szConfigFile)
{
	FILE *f=fopen(szConfigFile, "w");

	if(f==0)
		return false;

	fprintf(f, "[Input file]\n");
	fprintf(f, "%s\n\n", szInputFile);
	
	fprintf(f, "[Shift (n, m)]\n");
	fprintf(f, "%.4lf\t%.4lf\n\n", nShift, mShift);

	fprintf(f, "[Progression type (0=linear, 1=log)]\n");
	fprintf(f, "%d\n\n", nProgressionType);
	
	fprintf(f, "[Progression (from, to, step)]\n");
	fprintf(f, "%d\t%d\t%d\n\n", nFrom, nTo, nStep);

	fprintf(f, "[Use progression file, progression file]\n");
	fprintf(f, "%d\n%s\n\n", bUseExternalProgression, szProgressionFile);

	fclose(f);

	return true;
}
