#ifndef __PROGRESSION_H__
#define __PROGRESSION_H__

#include "../stdafx.h"
#include "../array.h"

//#include <iostream>

class Progression
{
public:
	enum
	{
		eLinear,
		eGeometric,
		eCustom
	};

	int nStart;	
	int nEnd;
	int nStep;
	
	int nProgression;

	CString szFile;

	Progression()
	{
		Reset();
	}

	void Reset()
	{
		nStart=0;
		nEnd=0;	
		nStep=0;
					
		szFile=_T("");

		nProgression=eLinear;
	}

	Array<int> GetProgression()	
	{		
		if(IsCustom())
			return Load(szFile);

		Array<int> progression;	
		int nValue;				

		nValue=nStart;			

		while(nValue<=nEnd)		
		{
			progression.Insert(nValue);

			if(nProgression==eLinear)
				nValue+=nStep;	
			else if(nProgression==eGeometric)
				nValue*=nStep;	
			else
				break;
		}
		
		return progression;
	}

	Array<int> Load(CString _szFile)
	{
		ASSERT(IsCustom());
		
		Array<int> prog;		

		FILE *f;
		f=fopen(_szFile, "r");

		if(f!=0)
		{
			int i, nCount;
			int nValue;			
		
			fscanf(f, "%d\n\n", &nCount);

			for(i=0; i<nCount; i++)
			{
				fscanf(f, "%d\n", &nValue);	
				prog.Insert(nValue);		
			}
		}
		return prog;
	}

	bool IsCustom() { return nProgression==eCustom; }
};

#endif //__PROGRESSION_H__