#include "stdafx.h"
#include "misc.h"

void SkipLine(FILE *f)
{
	char c=fgetc(f);

	while(c!=EOF && c!='\n')
		c=fgetc(f);
}

bool GetLine(FILE *f, CString& szStr)
{
	szStr=_T("");

	char c=fgetc(f);
	
	while(c!='\n' && c!=EOF)
	{
		szStr+=c;
		c=fgetc(f);
	}

	szStr.TrimRight();
	szStr.TrimLeft();
	
	return szStr.GetLength()>0;
}

#define IDS_OPEN_PROGRAM _T("\\Notepad.exe ");

bool ShowFile(LPCTSTR szFile)
{
	CString szWindowsDir;
 
	::GetWindowsDirectory(szWindowsDir.GetBuffer(256), 256);
	szWindowsDir.ReleaseBuffer();
 
	szWindowsDir+=IDS_OPEN_PROGRAM;
	szWindowsDir+=szFile;
 
	WinExec(szWindowsDir, SW_SHOW);
	
	return true;
}

#define IDS_EXPLORER_PROGRAM _T("\\explorer.exe ");

bool ShowFolder(LPCTSTR szFolder)
{
	CString szWindowsDir;
 
	::GetWindowsDirectory(szWindowsDir.GetBuffer(256), 256);
	szWindowsDir.ReleaseBuffer();
 
	szWindowsDir+=IDS_EXPLORER_PROGRAM;
	szWindowsDir+=szFolder;
 
	WinExec(szWindowsDir, SW_SHOW);
	
	return true;
}

bool GetFileFromUser(CString &szFile,
					 LPCTSTR szFilters,			//=0
					 CWnd *pWnd,				//=0
					 LPCTSTR szDefaultFileName,	//=0
					 DWORD dwFlags,				//=OFN_HIDEREADONLY | OFN_FILEMUSTEXIST
					 LPCTSTR szDefaultExt		//=0
					 )
{
	CFileDialog dlg(
		TRUE,
		szDefaultExt,
		szDefaultFileName,
		dwFlags,
		CString(szFilters)+"All files (*.*)|*.*||",
		pWnd);

	if(dlg.DoModal()==IDOK)
	{
		szFile=dlg.GetPathName();
		return true;
	}
	
	return false;		
}

#include <fstream>

using namespace std;

long ShowBigFile(string szFile, long nData, long nOffset)
{
	ifstream in;
	ofstream out;

	in.open(szFile.c_str(), ios::in);

	if(!in)
		return 0;
	
	out.open((szFile+".sample").c_str(), ios::out);

	if(!out)
		return 0;

	long nRead=0, nWritten=0;
	char c;

	while(in.get(c) && nWritten<nData) //.get(c))
	{
		//in >> c;
		nRead++;

		if(nRead>nOffset)
		{
			//out << c;
			out.put(c);
			nWritten++;
		}
	}

	in.close();
	out.close();

	ShowFile((szFile+".sample").c_str());	

	return nWritten;
}
