// BidimensionalMovingAverage.cpp: implementation of the BidimensionalMovingAverage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DMA_2D.h"
#include "BidimensionalMovingAverage.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BidimensionalMovingAverage::BidimensionalMovingAverage()
{
	dCurrentSum=0;
}

BidimensionalMovingAverage::~BidimensionalMovingAverage()
{
}

double BidimensionalMovingAverage::CalculateAverage(int iPoint, int jPoint)
{
	dCurrentSum=0;

	int i=0, j=0;

	for(i=0; i<nXSize; i++)
	{
		for(j=0; j<nYSize; j++)
		{
			dCurrentSum+=data.GetData(iPoint-i+nXShift, jPoint-j+nYShift);
		}
	}

	return dCurrentSum/(nXSize*nYSize);
}

double BidimensionalMovingAverage::ShiftX(int iPoint, int jPoint)
{
	int i;

	for(i=0; i<nYSize; i++)
	{
		dCurrentSum-=data.GetData(iPoint-nXSize+nXShift, jPoint-i+nYShift);
		dCurrentSum+=data.GetData(iPoint+nXShift,        jPoint-i+nYShift);
	}

	return dCurrentSum/(nXSize*nYSize);
}

double BidimensionalMovingAverage::ShiftY(int iPoint, int jPoint)
{
	int j;

	for(j=0; j<nXSize; j++)
	{
		dCurrentSum-=data.GetData(iPoint-j+nXShift,		jPoint-nYSize+nYShift);
		dCurrentSum+=data.GetData(iPoint-j+nXShift,		jPoint+nYShift       );
	}

	return dCurrentSum/(nXSize*nYSize);
}

