#ifndef __BIDIMENSIONAL_MOVING_AVG_H__
#define __BIDIMENSIONAL_MOVING_AVG_H__ 

// BidimensionalMovingAverage.h: interface for the BidimensionalMovingAverage class.
//
//////////////////////////////////////////////////////////////////////

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <assert.h>

class CMatrixData
{
public:
	
	CMatrixData()
	{
		pData=0;
		nXSize=0;
		nYSize=0;
	}

	//CMatrixData(double *_pData, int _nXSize, int _nYSize)
	CMatrixData(double **_pData, int _nXSize, int _nYSize)
	{
		pData=_pData;
		nXSize=_nXSize;
		nYSize=_nYSize;
	}

	//double *pData;
	double **pData;

	int nXSize, nYSize;

	double GetData(int i, int j)
	{
		assert(i>=0 && i<nXSize);
		assert(j>=0 && j<nYSize);

		//return pData[i*nYSize+j];
		return pData[i][j];
	}
};

class BidimensionalMovingAverage  
{
public:
	BidimensionalMovingAverage();
	virtual ~BidimensionalMovingAverage();

	int nXSize, nYSize;
	int nXShift, nYShift;

	void SetSize(int _nXSize, int _nYSize)
	{
		nXSize=_nXSize;
		nYSize=_nYSize;
	}

	void SetShift(int _nXShift, int _nYShift)
	{
		nXShift=_nXShift;
		nYShift=_nYShift;
	}

	double dCurrentSum;

	double CalculateAverage(int iPoint, int jPoint);
	double ShiftX(int iPoint, int jPoint);
	double ShiftY(int iPoint, int jPoint);

	CMatrixData data;

	//void SetMatrixData(double *_pData, int _nXSize, int _nYSize)
	void SetMatrixData(double **_pData, int _nXSize, int _nYSize)
	{
		data.pData=_pData;
		data.nXSize=_nXSize;
		data.nYSize=_nYSize;
	}
};

#endif // __BIDIMENSIONAL_MOVING_AVG_H__