// DMA_2D_Dlg.cpp : implementation file
//
#include "stdafx.h"
#include "DMA_2D.h"
#include "DMA_2D_Dlg.h"

#include "../classes/Misc.h"
#include <math.h>

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMA_2D_Dlg dialog

CDMA_2D_Dlg::CDMA_2D_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMA_2D_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMA_2D_Dlg)
	m_szConfigFile = _T("");
	m_generateMovingAverage = FALSE;
	m_bOptimize = TRUE;
	m_nOutputPrecision = 5;
	m_bNormalize = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMA_2D_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMA_2D_Dlg)
	DDX_Control(pDX, IDC_STATIC_DIMENSION, m_staticDimensions);
	DDX_Text(pDX, IDC_STATIC_CONFIG, m_szConfigFile);
	DDX_Check(pDX, IDC_GENERATE_MA, m_generateMovingAverage);
	DDX_Check(pDX, IDC_OPTIMIZE, m_bOptimize);
	DDX_Text(pDX, IDC_OUTPUT_PRECISION, m_nOutputPrecision);
	DDX_Check(pDX, IDC_NORMALIZE, m_bNormalize);
	//}}AFX_DATA_MAP

	DDX_Text(pDX,	IDC_INPUT_FILE,					configuration.szInputFile);
	
	DDX_Text(pDX,	IDC_N_SHIFT,					configuration.nShift);
	DDX_Text(pDX,	IDC_M_SHIFT,					configuration.mShift);
	
	DDX_Text(pDX,	IDC_FROM,						configuration.nFrom);
	DDX_Text(pDX,	IDC_TO,							configuration.nTo);
	DDX_Text(pDX,	IDC_STEP,						configuration.nStep);
	
	DDX_CBIndex(pDX,IDC_PROGRESSION_TYPE,			configuration.nProgressionType);

	DDX_Check(pDX,	IDC_USE_EXTERNAL_PROGRESSION,	configuration.bUseExternalProgression);
	DDX_Check(pDX,	IDC_GENERATE_MA,				configuration.bGenerateAvg);

	DDX_Text(pDX,	IDC_PROGRESSION_FILE,			configuration.szProgressionFile);
}

void CDMA_2D_Dlg::UpdateControls()
{
	UpdateData(TRUE);

	/*
	GetDlgItem(IDC_DMA_WEIGHT)->ShowWindow( (configuration.nComputationType==4 || configuration.nComputationType==8) ? SW_SHOW : SW_HIDE );
	GetDlgItem(IDC_STATIC_DMA_WEIGHT)->ShowWindow( (configuration.nComputationType==4 || configuration.nComputationType==8)  ? SW_SHOW : SW_HIDE );
	*/
}


BEGIN_MESSAGE_MAP(CDMA_2D_Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMA_2D_Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD_CONFIG, OnLoadConfig)
	ON_BN_CLICKED(IDC_SAVE_CONFIG, OnSaveConfig)
	ON_BN_CLICKED(IDC_CALCULATE, OnCalculate)
	ON_BN_CLICKED(IDC_VIEW_PROGRESSION_FILE, OnViewProgressionFile)
	ON_BN_CLICKED(IDC_VIEW_INPUT_FILE, OnViewInputFile)
	ON_BN_CLICKED(IDC_BROWSE_INPUT_FILE, OnBrowseInputFile)
	ON_BN_CLICKED(IDC_LOAD_PROGRESSION_FILE, OnLoadProgressionFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMA_2D_Dlg message handlers

BOOL CDMA_2D_Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDMA_2D_Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMA_2D_Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMA_2D_Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMA_2D_Dlg::OnLoadConfig() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	static CString szFile;

	if(!GetFileFromUser(szFile, "Configuration files (*.txt)|*.txt|", this, szFile))
		return;

	if(configuration.Load(szFile))
	{
		m_szConfigFile=szFile;
		UpdateData(FALSE);
		UpdateControls();
	}
	else
		AfxMessageBox("Error opening config file");
}

void CDMA_2D_Dlg::OnSaveConfig() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	m_szConfigFile.TrimLeft();
	m_szConfigFile.TrimRight();
	if(m_szConfigFile=="")
	{
		AfxMessageBox("Please enter config file name");
		return;
	}

	CFileDialog dlg(
		FALSE,
		NULL,
		m_szConfigFile,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST, 
		"Configuration files (*.txt)|*.txt|All files (*.*)|*.*||",
		this);

	if(dlg.DoModal()==IDOK)
	{
		if(configuration.Save(dlg.GetPathName()))
		{
			m_szConfigFile=dlg.GetPathName();
			UpdateData(FALSE);
		}
		else
			AfxMessageBox("Error saving config file");
	}
}

#include "../classes/Array.h"
#include "../classes/config/progression.h"
#include "BidimensionalMovingAverage.h"
#include "../classes/round.h"

void CDMA_2D_Dlg::OnCalculate() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	Progression progression;

	if(configuration.bUseExternalProgression)
	{
		progression.nProgression=Progression::eCustom;
		progression.szFile=configuration.szProgressionFile;
	}
	else
	{
		progression.nStart=configuration.nFrom;
		progression.nEnd=configuration.nTo;
		progression.nStep=configuration.nStep;
		progression.nProgression=configuration.nProgressionType;
	}

	Array<int> aProg;

	aProg=progression.GetProgression();

	if(aProg.IsEmpty())
	{
		AfxMessageBox("Progression is empty");
		return;
	}

	double **data_in=0;
	double **data_out=0;
	int nRows=0, nColumns=0;

	if(!LoadData(configuration.szInputFile, &data_in, nRows, nColumns))
	{
		AfxMessageBox("Error loading data");
		return;
	}

	if(m_bNormalize)
		NormalizeData(data_in, nRows, nColumns);

	AllocData(&data_out, nRows, nColumns);

	int k, nProgression=aProg.GetCount();

	Array<double> aSumDiffSQ;
	aSumDiffSQ.SetSize(nProgression);
	aSumDiffSQ.ZeroMem();

	//-------------------------------------------------------
	//apro il file in scrittura - azzeramento
	{
		FILE *fout;

		CString szOutFile;
		szOutFile=configuration.szInputFile+".out.txt";

		fout=fopen(szOutFile, "w");

		if(fout==0)
		{
			AfxMessageBox("Error writing to "+szOutFile);
			return;
		}

		fclose(fout);
	}
	//-------------------------------------------------------

	for(k=0; k<nProgression; k++)
	{
		int nAvgRows, nAvgColumns;

		nAvgRows=(int)sqrt(aProg[k]);
		nAvgColumns=nAvgRows;

		//eseguo il calcolo
		BidimensionalMovingAverage bma;

		bma.SetMatrixData((double **)data_in, nRows, nColumns);
		
		int nXShift, nYShift;

		nXShift=Round( nAvgRows*configuration.nShift);
		nYShift=Round( nAvgColumns*configuration.mShift);

		if(configuration.nShift==1)
			nXShift=nXShift-1;
		if(configuration.mShift==1)
			nYShift=nYShift-1;

		bma.SetSize(nAvgRows, nAvgRows);
		bma.SetShift(nXShift, nYShift);

		ZeroData(data_out, nRows, nColumns);

		int i, j;

		if(m_bOptimize)
		{
			int iInitialX, iFinalX, iInitialY, iFinalY;

			iInitialX=nAvgRows-1-nXShift;
			iInitialY=nAvgRows-1-nYShift;

			iFinalX=nRows-nXShift;
			iFinalY=nColumns-nYShift;

			for(j=iInitialY; j<iFinalY; j++)
			{
				for(i=iInitialX; i<iFinalX; i++)
				{
					if(i==iInitialX)
						data_out[i][j]=bma.CalculateAverage(i, j);
					else
						data_out[i][j]=bma.ShiftX(i, j);
				}
			}
		}
		else
		{
			for(i=nAvgRows-1-nXShift; i<nRows-nXShift; i++)
			{
				for(j=nAvgRows-1-nYShift; j<nColumns-nYShift; j++)
				{
					data_out[i][j]=bma.CalculateAverage(i, j);
				}
			}
		}

		//scrivo i risultati
		if(m_generateMovingAverage)
		{
			CString szFileOut;
			
			if(m_bOptimize)
				szFileOut.Format("%s.%d.out.txt", configuration.szInputFile, aProg[k]);
			else
				szFileOut.Format("%s.%d.out.no_opt.txt", configuration.szInputFile, aProg[k]);

			int nPrecision=20;
			
			FILE *f=fopen(szFileOut, "w");

			if(f==0)
			{
				AfxMessageBox("Error writing to "+szFileOut);
				break;
			}

			for(i=0; i<nRows; i++)
			{
				for(j=0; j<nColumns; j++)
					fprintf(f, "%.*f\t", nPrecision, data_out[i][j]);
				
				fprintf(f, "\n");
			}

			fprintf(f, "\n");

			fclose(f);
		}

		double dSumDiffSq=0;
		int nCount=0;
		double dDifference;

		//calcolo differenze al quadrato
		for(i=nXShift; i<nRows-nAvgRows+nXShift; i++)
		{
			for(j=nYShift; j<nColumns-nAvgColumns+nYShift; j++)
			{
				dDifference=data_out[i][j]-data_in[i][j];

				dSumDiffSq+=(dDifference*dDifference);
				nCount++;
			}
		}

		aSumDiffSQ[k]=dSumDiffSq; ///nCount;//(nRows-nAvgRows)/(nColumns-nAvgColumns);

		//-------------------------------------------------
		//scrittura risultato parziale
		{
			FILE *fout;

			CString szOutFile;
			szOutFile=configuration.szInputFile+".out.txt";

			fout=fopen(szOutFile, "a");

			if(fout==0)
			{
				AfxMessageBox("Error writing to "+szOutFile);
				return;
			}

			int nPrecision=m_nOutputPrecision;

			fprintf(fout, "%d\t%.*lf\n", aProg[k], nPrecision, aSumDiffSQ[k]);

			fclose(fout);
		}
		//-------------------------------------------------

	}
	
	/*
	for(i=0; i<nRows; i++)
		delete[] data_out[i];
	delete[] data_out;

	for(i=0; i<nRows; i++)
		delete[] data_in[i];
	delete[] data_in;
	*/

	FreeData(data_in, nRows, nColumns);
	FreeData(data_out, nRows, nColumns);
}

bool CDMA_2D_Dlg::LoadData(CString szFile, double ***data_in, int &nRows, int &nColumns)
{
	CWaitCursor cursor;

	(*data_in)=0;
	nColumns=nRows=0;

	int nColumnsTemp=0;

	FILE *f;

	f=fopen(szFile, "r");

	if(f==0)
		return false;

	//calcola le dimensioni

	char c;

	bool inLine=false;
	bool inColumn=false;
	bool firstRow=true;
	bool bError=false;

	while(c=fgetc(f))
	{
		if(c==EOF || c=='\n')
		{
			if(inLine)
			{
				//nColumnsTemp++;

				if(firstRow)
				{
					nColumns=nColumnsTemp;
					firstRow=false;
				}
				else
				{
					if(nColumns!=nColumnsTemp)
					{
						CString str;
						str.Format("The number of columns of row %d is wrong (%d against %d)", nRows+1, nColumnsTemp, nColumns);
						AfxMessageBox(str);
						bError=true;
						break;
					}
				}

				nRows++;
				
				inLine=false;
				
				nColumnsTemp=0;
			}

			if(c==EOF)
				break;
		}
		else
		{
			if(inColumn)
			{
				if( isspace(c) )
				{
					inColumn=false;
				}
			}
			else
			{
				if( !isspace(c) )
				{
					nColumnsTemp++;
					inColumn=true;
				}
			}
			
			if(inColumn)
				inLine=true;
		}
	}

	CString str;
	str.Format("Data rows: %d Data colums:%d", nRows, nColumns);
	m_staticDimensions.SetWindowText(str);

	if(AfxMessageBox(str + "\n""Continue?", MB_YESNO)==IDNO)
		return false;

	if(bError)
	{
		fclose(f);
		return false;
	}

	AllocData(data_in, nRows, nColumns);

	rewind(f);

	//carico i dati

	int i, j;

	double dValue=0;

	for(i=0; i<nRows; i++)
	{
		for(j=0; j<nColumns; j++)
		{
			fscanf(f, "%lf\t", &dValue);
			(*data_in)[i][j]=dValue;
		}
	}

	fclose(f);

	return true;
}

void CDMA_2D_Dlg::ZeroData(double **data, int nRows, int nColumns)
{
	int i, j;

	if(data==0)
		return;	

	for(i=0; i<nRows; i++)
		for(j=0; j<nColumns; j++)
			data[i][j]=0;
}

void CDMA_2D_Dlg::NormalizeData(double **data, int nRows, int nColumns)
{
	double dMax= -LONG_MAX, dMin = LONG_MAX;

	int i, j;

	for(i=0; i<nRows; i++)
	{
		for(j=0; j<nColumns; j++)
		{
			if(data[i][j]>dMax)
				dMax = data[i][j];

			if(data[i][j]<dMin)
				dMin = data[i][j];
		}
	}

	for(i=0; i<nRows; i++)
	{
		for(j=0; j<nColumns; j++)
		{
			double dValue = (data[i][j]-dMin)/(dMax-dMin)*2-1;
			data[i][j] = dValue;
		}
	}

	if(false)
	{
		FILE *f = fopen("c:\\Normalized.txt", "w");

		for(i=0; i<nRows; i++)
		{
			for(j=0; j<nColumns; j++)
			{
				fprintf(f, "%lf\t", data[i][j]);
			}

			fprintf(f, "\n");
		}

		fclose(f);

		AfxMessageBox("");
	}
}

void CDMA_2D_Dlg::AllocData(double ***data, int nRows, int nColumns)
{
	int i, j;

	if(*data!=0)
		return;

	(*data)=new double *[nRows];

	for(i=0; i<nRows; i++)
		(*data)[i]=new double[nColumns];

	for(i=0; i<nRows; i++)
		for(j=0; j<nColumns; j++)
			(*data)[i][j]=0;
}

void CDMA_2D_Dlg::FreeData(double **data, int nRows, int nColumns)
{
	int i;

	if(data==0)
		return;

	for(i=0; i<nRows; i++)
		delete[] data[i];

	delete[] data;
}

void CDMA_2D_Dlg::OnViewProgressionFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	ShowFile(configuration.szProgressionFile);
}

void CDMA_2D_Dlg::OnViewInputFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	ShowFile(configuration.szInputFile);
}

void CDMA_2D_Dlg::OnBrowseInputFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	static CString szFile;

	if(!GetFileFromUser(szFile, "Data files (*.txt)|*.txt|", this, szFile))
		return;

	configuration.szInputFile=szFile;
	UpdateData(FALSE);
}

void CDMA_2D_Dlg::OnLoadProgressionFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	static CString szFile;

	if(!GetFileFromUser(szFile, "Progression files (*.txt)|*.txt|", this, szFile))
		return;

	configuration.szProgressionFile=szFile;
	UpdateData(FALSE);	
}
