// DMA_2D_Dlg.h : header file
//

#if !defined(AFX_DMA_2D_Dlg_H__B907DFDF_AC21_47AE_879F_4FE483C67BC4__INCLUDED_)
#define AFX_DMA_2D_Dlg_H__B907DFDF_AC21_47AE_879F_4FE483C67BC4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CDMA_2D_Dlg dialog
#include "../classes/config/Configuration.h"

class CDMA_2D_Dlg : public CDialog
{
	void UpdateControls();
	
	void AllocData(double ***data, int nRows, int nColumns);
	void FreeData(double **data, int nRows, int nColumns);
	void ZeroData(double **data, int nRows, int nColumns);
	void NormalizeData(double **data, int nRows, int nColumns);
	
	bool LoadData(CString szFile, double ***data, int &nDataSizeX, int &nDataSizeY);


// Construction
public:
	CDMA_2D_Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDMA_2D_Dlg)
	enum { IDD = IDD_DMA_2D_DIALOG };
	CStatic	m_staticDimensions;
	CString	m_szConfigFile;
	BOOL	m_generateMovingAverage;
	BOOL	m_bOptimize;
	int		m_nOutputPrecision;
	BOOL	m_bNormalize;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDMA_2D_Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

	CConfiguration configuration;

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDMA_2D_Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnLoadConfig();
	afx_msg void OnSaveConfig();
	afx_msg void OnCalculate();
	afx_msg void OnViewProgressionFile();
	afx_msg void OnViewInputFile();
	afx_msg void OnBrowseInputFile();
	afx_msg void OnLoadProgressionFile();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DMA_2D_Dlg_H__B907DFDF_AC21_47AE_879F_4FE483C67BC4__INCLUDED_)
